// Gary Yngve 11/20/2005
import java.io.*;
import java.util.*;

public class BuildGraph {
/*
buildGraph() loads the vertices from disk and constructs the edges.
Upon completion, the vertices lie in a public static ArrayList called vertices
and similarly for edges.

This is some nasty hacky code.  It reads in vertices with names
A & B, A & C, B & C & D, E & B, etc.  Then it creates cliques of vertices
sharing A's, sharing B's, etc., and constructs MSTs for those cliques.  Those
are the resulting edges.   So A & B, B & C, E & B would be a clique, and an MST
between them would need two edges.
*/

    public static ArrayList vertices;
    public static ArrayList edges;

    private static int distSqr(Vertex v1, Vertex v2) {
        return (v1.xcoord-v2.xcoord)*(v1.xcoord-v2.xcoord)
                 + (v1.ycoord-v2.ycoord)*(v1.ycoord-v2.ycoord);
    }

// UGLY!!!!!!!!!
    private static void makeEdges() {
        int n = vertices.size();
        boolean[][] arr = new boolean[n][n];
        Map map = new TreeMap();
        for(Iterator i = vertices.iterator(); i.hasNext(); ) {
            Vertex v = (Vertex) i.next();
             for(int k = 0; k < v.labelParts.length; k++) {
                 if (map.get(v.labelParts[k]) == null) {
                     map.put(v.labelParts[k],new ArrayList());
                 }
                 List l = (List)map.get(v.labelParts[k]);
                 l.add(v);
             }
         }
        for(Iterator i = map.keySet().iterator(); i.hasNext(); ) {
            List l = (List)map.get(i.next());
            int m = l.size();
            System.out.println(m);
            boolean[] row = new boolean[m];
            row[0] = true;
            int e = m-1;
            while(e > 0) {
                int min=99999999,mv1=-1,mv2=-1,mj=-1,mk=-1;
                for(int j = 0; j < m; j++)
                    for(int k = j+1; k < m; k++) {
                        Vertex v1=(Vertex)l.get(j);
                        Vertex v2=(Vertex)l.get(k);
                        if (row[j] ^ row[k]) {
                            int d = distSqr(v1,v2);
                            if (d < min) { // lazy.. should use a pq
                                mv1 = v1.id;
                                mv2 = v2.id;
                                min = d;
                                mj = j;
                                mk = k;
                            }
                        }
                    }
                row[mj] = row[mk] = true;
                arr[mv1][mv2] = arr[mv2][mv1] = true;
                e--;
            }
        }
        for(int j = 0; j < n; j++)
            for(int k = j+1; k < n; k++) {
                if (arr[j][k]) edges.add(new Edge((Vertex)vertices.get(j),(Vertex)vertices.get(k)));
            }
        for(Iterator i = edges.iterator(); i.hasNext(); ) {
            Edge e = (Edge)i.next();
            System.out.println(e.toString() + " = " + e.vertex1.toString() + " <--> " +
                e.vertex2.toString());
        }
    }

    public static void buildGraph() {
        Scanner sc;
        try {
            sc = new Scanner(new FileInputStream("vertices.txt"));
        } catch (Exception e) {throw new RuntimeException(e.toString());}
        vertices = new ArrayList();
        edges = new ArrayList();
        int k = 0;
        while(sc.hasNextLine()) {
            String s = sc.nextLine();
            System.out.println(s);
            Scanner sc2 = new Scanner(s);
            int x = (int)(0.75*(sc2.nextInt()-250)); // resized the image to
            int y = (int)(0.75*(sc2.nextInt()-100)); // fit on 1024x768
            if (!sc.hasNextLine()) throw new RuntimeException("file error");
            vertices.add(new Vertex(sc.nextLine(),x,y,k++));
        }
        makeEdges();
    }

    public static void main(String[] args) {
        buildGraph();
    }
}